@echo off

set CR_CR=------------------
set ADB_ROOT=%~d0
set ADB_HOME_X64=%ADB_ROOT%\adb_home
set ADB_SRC_X64=%~dp0
set ADB_TEMP_FILE=%ADB_HOME_X64%\temp.txt
set ADB_DEVICE_NAME=%1

rem test code
:: 1,16

rem error code
:: PC err
set ERR_MK_ADB_HOME=1
set ERR_CP_ADB_FILE=2
set ERR_CP_LIB_FILE=3
set ERR_CP_SH_FILE=4
set ERR_KILL_5037=5
set ERR_USB_DISCONNECTED=5
set ERR_MK_SD_DIR=6
set ERR_UPLOAD_FILE=7
set ERR_ADB_SHELL=8
set ERR_ADB_SHELL_PULL=8
:: Android err
set ERR_SD_2_DATALOCAL=9
set ERR_CHMOD=10
set ERR_SRC_NOT_D=11
set ERR_DATALOCAL_NOT_X=12
set ERR_DST_NOT_D=13
set ERR_SRC_NOT_F=14
set ERR_DST_NOT_F=15
set ERR_DEAMON_NOT_RUN=16

rem 1st, mk adb_home
::-------------------------------------------------------------
if not exist %ADB_HOME_X64% (
md %ADB_HOME_X64% && (
echo "[BAT][INFO] mk adb_home"
) || (
echo "[BAT][FATAL] mk adb_home"
set ADB_ERROR=%ERR_MK_ADB_HOME%
goto THEEND
)
)
::-------------------------------------------------------------




rem 2nd, copy adb files
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] copy adb files"

( copy "%ADB_SRC_X64%errbox.exe" %ADB_HOME_X64%\errbox.exe
) || (
echo "[BAT][FATAL] copy errbox.exe"
set ADB_ERROR=%ERR_CP_ADB_FILE%
goto THEEND
)

rem kill adb
( tasklist | find "adb.exe"
) && (
taskkill /f /im "adb.exe"
)

ping 127.0.0.1 -n 3 > nul

( copy "%ADB_SRC_X64%adb.exe" %ADB_HOME_X64%\adb.exe
) || (
echo "[BAT][FATAL] copy adb.exe"
set ADB_ERROR=%ERR_CP_ADB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%AdbWinApi.dll" %ADB_HOME_X64%\AdbWinApi.dll
) || (
echo "[BAT][FATAL] copy AdbWinApi.dll"
set ADB_ERROR=%ERR_CP_ADB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%activatorCMD.exe" %ADB_HOME_X64%\activatorCMD.exe
) || (
echo "[BAT][FATAL] copy activatorCMD.exe"
set ADB_ERROR=%ERR_CP_ADB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%checkproc-cmd" %ADB_HOME_X64%\checkproc-cmd
) || (
echo "[BAT][FATAL] copy checkproc-cmd"
set ADB_ERROR=%ERR_CP_ADB_FILE%
goto THEEND
)
::-------------------------------------------------------------




rem 3rd, copy lib files
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] copy lib files"

( copy "%ADB_SRC_X64%libmmcodec-scp-4-1-1.so" %ADB_HOME_X64%\libmmcodec-scp-4-1-1.so
) || (
echo "[BAT][FATAL] copy libmmcodec-scp-4-1-1.so"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%libmmcodec-scp-4-2-2.so" %ADB_HOME_X64%\libmmcodec-scp-4-2-2.so
) || (
echo "[BAT][FATAL] copy libmmcodec-scp-4-2-2.so"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%libmmcodec-scp-4-4.so" %ADB_HOME_X64%\libmmcodec-scp-4-4.so
) || (
echo "[BAT][FATAL] copy libmmcodec-scp-4-4.so"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%libmmcodec-scp-5-0.so" %ADB_HOME_X64%\libmmcodec-scp-5-0.so
) || (
echo "[BAT][FATAL] copy libmmcodec-scp-5-0.so"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%libmmcodec-scp-5-1.so" %ADB_HOME_X64%\libmmcodec-scp-5-1.so
) || (
echo "[BAT][FATAL] copy libmmcodec-scp-5-1.so"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%tga_scp" %ADB_HOME_X64%\tga_scp
) || (
echo "[BAT][FATAL] copy tga_scp"
set ADB_ERROR=%ERR_CP_LIB_FILE%
goto THEEND
)
::-------------------------------------------------------------




rem 4th, copy sh
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] copy shell"

( copy "%ADB_SRC_X64%no-root.sh" %ADB_HOME_X64%\no-root.sh
) || (
echo "[BAT][FATAL] copy no-root.sh"
set ADB_ERROR=%ERR_CP_SH_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%medium.sh" %ADB_HOME_X64%\medium.sh
) || (
echo "[BAT][FATAL] copy medium.sh"
set ADB_ERROR=%ERR_CP_SH_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%upload.bat" %ADB_HOME_X64%\upload.bat
) || (
echo "[BAT][FATAL] copy upload.sh"
set ADB_ERROR=%ERR_CP_SH_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%mksddir.sh" %ADB_HOME_X64%\mksddir.sh
) || (
echo "[BAT][FATAL] copy mksddir.sh"
set ADB_ERROR=%ERR_CP_SH_FILE%
goto THEEND
)

( copy "%ADB_SRC_X64%kill.sh" %ADB_HOME_X64%\kill.sh
) || (
echo "[BAT][FATAL] copy kill.sh"
set ADB_ERROR=%ERR_CP_SH_FILE%
goto THEEND
)
::-------------------------------------------------------------




rem 5th-0, 
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] check devices"
if not defined ADB_DEVICE_NAME (
echo "[BAT][FATAL] device not found."
set ADB_ERROR=%ERR_USB_DISCONNECTED%
goto THEEND
)
::-------------------------------------------------------------




rem 5th, KILL 5037
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] kill 5037"
call %ADB_HOME_X64%\activatorCMD.exe
( call %ADB_HOME_X64%\adb.exe -s %ADB_DEVICE_NAME% shell "exit;"
) || (
echo "[BAT][FATAL] usb not connected."
set ADB_ERROR=%ERR_KILL_5037%
goto THEEND
)
::-------------------------------------------------------------




rem 6th, mk sd dir
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] mk sdard"
( %ADB_HOME_X64%\adb.exe -s %ADB_DEVICE_NAME% shell < %ADB_HOME_X64%\mksddir.sh
) || (
echo "[BAT][FATAL] mk sdcard"
set ADB_ERROR=%ERR_MK_SD_DIR%
goto THEEND
)
::-------------------------------------------------------------





rem 7th, upload
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] upload"
( call %ADB_HOME_X64%\upload.bat %ADB_ROOT% %ADB_DEVICE_NAME%
) || (
echo "[BAT][FATAL] upload"
set ADB_ERROR=%ERR_UPLOAD_FILE%
goto THEEND
)
::-------------------------------------------------------------





rem 8th, adb shell
::-------------------------------------------------------------
echo %CR_CR%
echo "[BAT][INFO] adb shell"

( %ADB_HOME_X64%\adb.exe -s %ADB_DEVICE_NAME% shell < %ADB_HOME_X64%\medium.sh
) || (
echo "[BAT][FATAL] adb shell medium.sh"
set ADB_ERROR=%ERR_USB_DISCONNECTED%
goto THEEND
)

( %ADB_HOME_X64%\adb.exe -s %ADB_DEVICE_NAME% pull /data/local/tmp/tgascp/adb_error.txt %ADB_ROOT%/adb_home
) || (
echo "[BAT][FATAL] adb pull adb_error.txt"
set ADB_ERROR=%ERR_ADB_SHELL_PULL%
goto THEEND
)

if not exist %ADB_HOME_X64%\adb_error.txt (
echo "[BAT][FATAL] adb_error.txt not exist."
set ADB_ERROR=%ERR_ADB_SHELL_PULL%
goto THEEND
)

set /p SHELL_ERR_VAR= < %ADB_HOME_X64%\adb_error.txt
if %SHELL_ERR_VAR% gtr 0 (
echo "[BAT-SHELL][FATAL] find error in adb_error.txt"
set ADB_ERROR=%SHELL_ERR_VAR%
goto THEEND
)
::-------------------------------------------------------------

echo %CR_CR%
echo All done.
rem pause;
exit


:THEEND
rem call %ADB_HOME_X64%\errbox.exe %ADB_ERROR%
echo "̷뽫˴Ϣٰ"
pause > nul
exit %ADB_ERROR%
